
;###################################################################################
;
;       ########   ########   ########   ##    ##  ########   #######
;       ##    ##   ##    ##   ##         ##  ##    ##         ##    ##
;       ########   ########   ##         ####      #####      #######
;       ##         ##    ##   ##         ##  ##    ##         ##   ##
;       ##         ##    ##   ########   ##    ##  ########   ##    ##
;
;	-> Le code inject dans le prog
;
;###################################################################################

packer:

	mov	edx, [esp]			; edx est une valeur du kernel

;calcul du delta offset : ebp = decalage

	mov	ebx, offset packer
	sub	eax, ebx			;EntryPoint en eax au dmarrage
	mov	ebp, eax

	lea	eax, [ebp+GetKernel]		; choppe l'adresse du kernel
	call	eax
	lea	eax, [ebp+GetProcA]		; choppe l'adresse de GetProcAddress
	call	eax
	lea	eax, [ebp+GetAPIs]		; choppe les adresses des APIs voulues
	call	eax
	lea	eax, [ebp+Cryptage]		; on dcrypte
	call	eax

	mov     ah,43h
	int     68h
	cmp     ax,0F386h
	jnz     SoftICE_Not_Detected

	lea	eax, Titre
	add	eax, ebp
	lea	ecx, Message
	add	ecx, ebp
	call	[ebp+AMessageBoxA], NULL, ecx, eax, MB_ICONEXCLAMATION

	SoftICE_Not_Detected:
	mov eax, [AENTRYPOINT+ebp]
	jmp eax					; RETOUR A L'HOTE

;===============================================================================
;	GetKernel PROC
;	input:		edx = adresse appartenant au kernel
;	output:		kernel32 et PeHeader
;===============================================================================

GetKernel PROC

	mov	eax,edx				; On sauve cette valeur dans eax
	AND	edx,0FFFF0000h			; On diminue la recherche
	inc edx					;
						;
kernelboucle:					;
	dec	edx				; un cran de moins
	cmp	word ptr [edx], "ZM"		; Cherche le MZ Header
	jnz	kernelboucle			; on repart
						;
MZ_found:					;
	mov	ecx, edx			; ecx = adresse du MZ.
	mov	ecx, [ecx+03ch]			; ecx = adresse du PE header
	add	ecx, edx			; on aligne
	cmp	ecx, eax			;
	jg	boucle				; vrifie que c'est une adresse valide
	cmp	word ptr [ecx] , "EP"		; On a le PeHeader ?
	jnz	boucle				; Non ! on repart
						;
	mov	[ebp+kernel32], edx		; stocke l'ImageBase du kernel
	mov	[ebp+PeHeader], ecx		; stocke L'ImageBase du PeHeader
						;
	ret
GetKernel endp

;===============================================================================
;	GetProcA PROC
;	input:		kernel32 et PeHeader
;	output:		AGetProcAddress = adresse de GetProcAddress
;	Succes : EAX = adresse de GetProcAddress	Failed : EAX = 0
;===============================================================================

GetProcA PROC

	mov	edi, [ebp+PeHeader]		; EDI = adresse du PeHeader
	mov	esi, [edi+78H]			; 78H = addresse de l'export table
	add	esi, [ebp+kernel32]		; on normalise
	mov	edi, [esi+12]			; adresse du nom du module
	add	edi, [ebp+kernel32]		; on normalise
	cmp	dword ptr [edi], "NREK"		; on a bien l'export table du Kernel ?
	jne	GetProcA_ERROR			;

	mov	eax, dword ptr [esi+1Ch]	; Tableau des Adresses des fonctions exports
	add	eax, [ebp+kernel32]		; (EN DWORDS)
	mov	[ebp+Fonctions], eax		;
						;
	mov	eax, dword ptr [esi+20h]	; Adresses des noms des fonctions exports
	add	eax, [ebp+kernel32]		;
	mov	[ebp+Names], eax		;
						;
	mov	eax, dword ptr [esi+24h]	; Tableau des exported oridinals
	add	eax, [ebp+kernel32]		; (EN WORDS)
	mov	[ebp+Ordinals], eax		;


	xor	eax, eax			; EAX sert de compteur
	mov	edx, [ebp+Names]		; EDX pointe une RVA

Next_API:

	cmp	dword ptr [edx], 0		; la dernire RVA ?
	je	GetProcA_ERROR			; erreur...
	mov	edi, [edx]			; EDI pointe le nom d'une API
	add	edi, [ebp+kernel32]		; on normalise
	lea	esi, [ebp+NGetProcAddress]	; ESI pointe le nom recherch

compare:
	cmpsb					; les 2 bytes sont pareils ?
	jne	Inc_Compteur			; non ? on passe  la fonction suivante
	cmp	byte ptr [edi], 0		; la chane entire est valide
	je	GetProcA_Found			; -> hh, on l'a !
	jmp	compare				; sinon on prend la prochaine lettre

Inc_Compteur:
	inc	eax				; incrmente le compteur
	add	edx, 4				; prochaine RVA
	jmp	Next_API			; on recherche de nouveau

GetProcA_Found:

	imul	eax, 2				; multiplie le compteur par 2 (WORDS)
	add	eax, [ebp+Ordinals]		; choppe l'ordinal qui correspond
	movzx	eax, word ptr [eax]		; EAX = L'Ordinal
	imul	eax, 4				; multiplie l'Ordinal par 4 (DWORDS)
	add	eax, [ebp+Fonctions]		; Pointe l'adresse de GetProcAddress
	mov	eax, [eax]			; EAX = RVA de GetProcAddress
	add	eax, [ebp+kernel32]		; on normalise
	mov	[ebp+AGetProcAddress], eax	; Et on sauve l'adresse de GetProcAddress

	ret

GetProcA_ERROR:
	xor	eax, eax
	ret

GetProcA endp


;===============================================================================
;	GetAPIs	PROC
;	input:		AGetProcAddress = adresse de GetProcAddress
;===============================================================================

GetAPIs	PROC

;-------------------------------------------------------------------------------
; Fonctions qui rcupre toutes les APIs dont nous avons besoin
; dans Kernel32.dll
;-------------------------------------------------------------------------------

                                               ;
	lea	esi, NExitProcess              ;
	lea	edi, AExitProcess              ; On prpare la recherche des APIs
	add	esi, ebp                       ; On normalise
	add	edi, ebp                       ;
                                               ;
find_apis:                                     ;
                                               ;
	push	esi                            ; Nom de l'API
	push	[ebp+kernel32]                 ; Module de Kernel32
	call	[ebp+AGetProcAddress]          ; API qui nous donne
	cmp	eax,0                          ; l'adresse de l'API recherche
	je	on_se_trace                    ;
	stosd                                  ; copie l'adresse l o pointe EDI
                                               ; puis ajoute 4  EDI
choppe_prochaine_api:                          ;
	inc	esi                            ; on choppe le prochain nom d'API
	cmp	byte ptr [esi], 0              ;
	jne	choppe_prochaine_api           ;
                                               ;
	inc	esi                            ;
	cmp	byte ptr [esi], 0FFh           ; On regarde si on est arriv  la fin
	jne	find_apis                      ;

;-------------------------------------------------------------------------------
; Fonctions qui rcupre toutes les APIs dont nous avons besoin
; dans User32.dll
;-------------------------------------------------------------------------------

	lea	eax, [ebp+Nuser32]             ; On prend l'ImageBase de user32.dll
	push	eax                            ; grace  GetModuleHandle.
	call	[ebp+AGetModuleHandleA]        ;
	cmp	eax, 0                         ;
	je	on_se_trace                    ;
	mov	[ebp+user32],eax               ; On stocke cette valeur dans user32.
                                               ;
	lea	esi, NMessageBoxA              ; On recherche en premier MessageBoxA
	lea	edi, AMessageBoxA              ;
	add	esi, ebp                       ; On normalise
	add	edi, ebp                       ;
                                               ;
find_user_apis:                                ;
                                               ;
	push	esi                            ; On refait la mme chose qu'avec Kernel32
	push	[ebp+user32]                   ; pour trouver toutes les adresses des APIs
	call	[ebp+AGetProcAddress]          ; de user32.dll dont nous avons besoin
	cmp	eax,0                          ;
	je	on_se_trace                    ;
	stosd                                  ; copie l'adresse l o pointe EDI
                                               ; puis ajoute 4  EDI
choppe_user_api:                               ;
	inc	esi                            ; on choppe le prochain nom d'API
	cmp	byte ptr [esi], 0              ;
	jne	choppe_user_api                ;
                                               ;
	inc	esi                            ;
	cmp	byte ptr [esi], 0FFh           ; On regarde si on est arriv  la fin
	jne	find_user_apis                 ;
                                               ;
	ret


on_se_trace:
	ret

GetAPIs	endp

;===============================================================================
;	Cryptage PROC
;===============================================================================
Cryptage PROC
;dcrypte la premiere section

	mov     ecx, [ebp+VIRTUALSIZEps]	; taille  crypter
	mov	esi, [ebp+VIRTUALOFFSETps]	;
	add	esi, [ebp+IMAGEBASE]		; esi = pointeur sur le code  crypter
	xor	ah, ah			; ah = 0 => future incrmentation de la cl
	mov	al, 033h		; la cl de cryptage

de_crypt:
	xor	byte ptr [esi], al	; le cryptage par XOR
	inc	esi			; prochain DWORD

	cmp	al, 0CCh		; effet de balancier entre 2 valeurs
	je	de_dansunsens		; pour la cl
	cmp	al, 10h			;
	je	de_dansautresens	;
	jmp	de_crypt_continue	;

de_dansunsens:
	xor	ah, ah			;
	inc	ah			; ah = 1 : on inverse le sens
	jmp	de_crypt_continue	;
de_dansautresens:
	xor	ah, ah			; ah = 0 : on inverse le sens
	jmp	de_crypt_continue		;

de_crypt_continue:
	test	ah, ah			; ah = 0 => on incremente la cl
	je	de_incremente_cle	;
					; sinon ah=1 => on decremente la cl
de_decremente_cle:
	dec	al			; al--
	jmp	de_cryptboucle
de_incremente_cle:
	inc	al			; al++
	jmp	de_cryptboucle

de_cryptboucle:
	dec	ecx			; ecx--
	test	ecx, ecx		; fini ?
	jnz	de_crypt		; non : on boucle

	ret
Cryptage endp

;===============================================================================


AENTRYPOINT	dd	?
IMAGEBASE	dd	?
VIRTUALSIZEps	dd	?
VIRTUALOFFSETps	dd	?
ITD		dd	0

kernel32	dd	0
user32		dd	0
PeHeader	dd	0
Fonctions	dd	0
Names		dd	0
Ordinals	dd	0


;__--==*** Apis dans Kernel32.dll ***==--__
;

NGetProcAddress		db	"GetProcAddress",0
NExitProcess		db	"ExitProcess",0
NGetModuleHandleA	db	"GetModuleHandleA",0
db 0FFh

AGetProcAddress		dd	0
AExitProcess		dd	0
AGetModuleHandleA	dd	0

;__--==*** Apis dans User32.dll ***==--__
;
Nuser32			db	"User32.dll",0
NMessageBoxA		db	"MessageBoxA",0 
db 0FFh
AMessageBoxA		dd	0

;Datas globales
;----------------

Titre			db	"[TiPiaX Strange Crypter]", 0
Message			db	"Softice is for crackers",13,10
			db	"and i don't like crackers !",0

packerend:

;###################################################################################
;
;       ########   ########   ########   ##    ##  ########   #######
;       ##    ##   ##    ##   ##         ##  ##    ##         ##    ##
;       ########   ########   ##         ####      #####      #######
;       ##         ##    ##   ##         ##  ##    ##         ##   ##
;       ##         ##    ##   ########   ##    ##  ########   ##    ##
;
;	-> Fin du code inject dans le prog
;
;###################################################################################

